#include "expression.hpp"
#include "parser.hpp"
#include "symbol-table.hpp"
#include "lex.hpp"

using namespace std;

int main() {
   Lex lex{cin, cout, "> ", "| "};
   SymbolTable symtab;
   Parser parser{lex, symtab};

   /* Abort on syntax errors, i.e. no recovery takes place
      except by printing a final error message and exiting
      the program. */
   try {
      /* Run the outer loop as long as we receive syntactically
	 correct expressions. */
      ExpressionPtr expr;
      while (expr = parser.getExpr()) {
	 cout << expr->evaluate() << endl;
      }
   } catch (Parser::Exception e) {
      cout << endl << e.what() << endl;
   }
}
