#include <iostream>
#include "token.hpp"

const char* const Token::symname[BECOMES+1] = {
   "ERROR", "END", "VARIABLE", "LPAREN",
   "RPAREN", "VALUE", "ADD", "SUB", "MUL", "DIV", "SEMICOLON", "BECOMES"
};

std::ostream& operator<<(std::ostream& out, const Token& token) {
   out << Token::symname[token.symbol];
   if (token.symbol == Token::VARIABLE && token.identifier.length() > 0) {
      out << " (" << token.identifier << ")";
   } else if (token.symbol == Token::VALUE) {
      out << " (" << token.value << ")";
   }
   return out;
}
