#ifndef TOKEN_H
#define TOKEN_H

#include <string>
#include "expression.hpp"

struct Token {
   typedef enum {ERROR, END, VARIABLE, LPAREN,
      RPAREN, VALUE, PLUS, MINUS, MUL, DIV, SEMICOLON, BECOMES} Symbol;
   static const char* const symname[BECOMES+1];
   Symbol symbol;
   std::string identifier;
   Value value;

   Token() : symbol{ERROR} {};
   Token(Symbol symbol_) : symbol{symbol_} {};
   Token(Symbol symbol_, const std::string& identifier_) :
      symbol{symbol_}, identifier{identifier_}, value{} {
   }
   Token(Symbol symbol_, Value value_) :
      symbol{symbol_}, value{value_} {
   }

   bool valid() const {
      return symbol > END;
   }
};

std::ostream& operator<<(std::ostream& out, const Token& token);

#endif
